
#include <stdio.h>
#include <string.h>
#include "pz.h"


static PzModule *module;
int count = 0;
int size;

static void counter_draw(PzWidget *wid, ttk_surface srf)
{	
	char s[48];
	
	snprintf(s, 48, "%d", count);
	size = strlen(s);
	size *= 2;

	pz_vector_string_center(srf, s, wid->w/2, wid->h/2, wid->w/size, wid->h/size, 1, ttk_ap_getx("window.fg")->color);
}

static int counter_events(PzEvent *e)
{
	int ret = TTK_EV_CLICK;

	
	switch(e->type) {
	case PZ_EVENT_BUTTON_DOWN:
		switch(e->arg) {
		case PZ_BUTTON_MENU:
			pz_close_window(e->wid->win);
			break;
		case PZ_BUTTON_ACTION:
			count++;
			e->wid->dirty = 1;
			break;
		case PZ_BUTTON_PLAY:
			count = 0;
			e->wid->dirty = 1;
			break;
		case PZ_BUTTON_PREVIOUS:
			count--;
			e->wid->dirty = 1;
			break;
		default:
			ret = TTK_EV_UNUSED;
		}
		break;
	default:
		ret = TTK_EV_UNUSED;
		break;
	}
	return ret;
}

static PzWindow *new_counter()
{
	PzWindow *ret;
	
	ret = pz_new_window(_("Counter"), PZ_WINDOW_NORMAL);
	pz_add_widget(ret, counter_draw, counter_events);
	
	return pz_finish_window(ret);
}

static void init_counter()
{
	module = pz_register_module("counter", NULL);
	pz_menu_add_action("/Extras/Utilities/Counter", new_counter);
}

PZ_MOD_INIT(init_counter)
